try{
      const GismeteoBar_PREF_SVC   = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      const GismeteoBar_ROOT_OBJ = GismeteoBar_PREF_SVC.getBranch(null);
      const GismeteoBar_PREF = GismeteoBar_PREF_SVC.getBranch("gismeteobar.");
           
      const PR_RDONLY = 0x01; 
      const PR_WRONLY = 0x02; 
      const PR_RDWR = 0x04; 
      const PR_CREATE_FILE = 0x08; 
      const PR_APPEND = 0x10; 
      const PR_TRUNCATE = 0x20; 
      const PR_SYNC = 0x40; 
      const PR_EXCL = 0x80;

      const dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
      const dir = dirService.get("ProfD", Components.interfaces.nsIFile);

   }
catch(err) {alert(err);}

GismeteoBar_PREF.setCharPref("timeUpdate","0||6||12||18||24");

var Eflag;

function stopAction() { Eflag=0; setTimeout(beforeshowPrognoz, 2000); }

function CreateList()
{
	try { index=GismeteoBar_PREF.getCharPref("selectIndex");
	}catch(err) {index=-1;} 

	file="chrome://gismeteobar/content/gmbartlist.xml";
	resultat=loadFIleFromHTTP(file);
	var xrequest = new DOMParser().parseFromString(resultat, 'text/xml');
	var menu = document.getElementById("Gismeteo-Towns-Menu");
	for(var i=menu.childNodes.length - 1; i>=0; i--) {
		menu.removeChild(menu.childNodes.item(i));
	}
	var j=0;
	for (i=0;i<xrequest.documentElement.childNodes.length;i++)
	{
		try{ 
			var node=xrequest.documentElement.childNodes.item(i);
			if(node.nodeType==1) 
			{
				name=node.getAttribute("n"); 
				townIndex=node.getAttribute("i");
				country=node.getAttribute("c");
				var tempItem = null;
				tempItem = document.createElement("listitem");
				tempItem.setAttribute("label", name);
				tempItem.setAttribute("value", townIndex);
				tempItem.setAttribute("index", j);
				tempItem.setAttribute("country", country);
				menu.appendChild(tempItem);
				if(townIndex==27612) 
				{ 
					if(index==-1)
					{
						index=j;
						GismeteoBar_PREF.setCharPref("selectIndex",j);
					}
				} 
				j++;
			}    
		} catch(err) {alert(err);}
	}
	document.getElementById("Gismeteo-Towns-Menu").selectedIndex = index;	
}

function selectTown()
{

 	var searchTown = document.getElementById("Gismeteo-Towns-Menu");
	GismeteoBar_PREF.setCharPref("selectIndex",searchTown.selectedIndex);
	var TownIndex = searchTown.selectedItem;
	var index=TownIndex.getAttribute("value");
	var name=TownIndex.getAttribute("label");
	var country=TownIndex.getAttribute("country");
	GismeteoBar_PREF.setCharPref("selectIndexTown",index);
	GismeteoBar_PREF.setCharPref("selectNameTown",escape(name));
	GismeteoBar_PREF.setCharPref("selectNameCountry",escape(country));		
	showPrognoz(index,name);
}

function beforeshowPrognoz()
{	
	try { index=GismeteoBar_PREF.getCharPref("selectIndexTown");
	} catch(err) {index=27612; GismeteoBar_PREF.setCharPref("selectIndexTown","27612");}

	try {name=GismeteoBar_PREF.getCharPref("selectNameTown");
	} catch(err) {name='%u041C%u043E%u0441%u043A%u0432%u0430'; GismeteoBar_PREF.setCharPref("selectNameTown",name);}	
	showPrognoz(index,name);	
}


///////////////////////////////////  ()//////////////

function showPrognoz(index,name)
{

	var windoc;
	if (Eflag==0) windoc=window.document;
	else windoc=window.opener.document;
	
	pathDir=dir.path;
	file=index+".xml";

	var today=new Date();
	var day=today.getDate();
	var month=today.getMonth();
	var year=today.getFullYear();
	var hour=today.getHours();
	var minute=today.getMinutes();
	var date=day+'||'+month+'||'+year+'||'+hour+'||'+minute;

	fileWithPath=pathDir+"\\"+index+".xml";
		
        timeFile=fileTime(fileWithPath);


	if  (timeFile!="Error")
	{
		today=new Date(timeFile);
		var day=today.getDate();
		var month=today.getMonth();
		var year=today.getFullYear();
		var hour=today.getHours();
		var minute=today.getMinutes();
		timeFile=day+"||"+month+"||"+year+"||"+hour+"||"+minute;
		resultat=timeUpdate(date,timeFile);
		if (resultat==false)
		{
		   resultat=loadFIle(file,pathDir);
		   if (resultat=="Error")
		   {
	        	fileNameFromHTTP="http://r.gismeteo.ru/r.php?sh+BARM+http://informer.gismeteo.ru/xml/"+index+"_1.xml";
	        	resultat=loadFIleFromHTTP(fileNameFromHTTP);
	      		if (resultat=="Error")
	      		{
				clear();
		   		return;
	      		}
			else
	      		{
		   	   file=dir.path+'\\'+index+'.xml';
			   data =resultat;
		   	   saveXMLFile(file,data);
	      		} 			
		   }
		   		
		}
		else
		{
	            fileNameFromHTTP="http://r.gismeteo.ru/r.php?sh+BARM+http://informer.gismeteo.ru/xml/"+index+"_1.xml";
	            resultat=loadFIleFromHTTP(fileNameFromHTTP);
	      	    if (resultat=="Error")
	      	    {
			clear();
			return;
	      	    }
		    else
	      	    {
		       GismeteoBar_PREF.setCharPref("fileTime",date);
		       file=dir.path+'\\'+index+'.xml';
     		       //data = encodeClass.ConvertFromUnicode(resultat);
		       data =resultat;
		       saveXMLFile(file,data);
		 
	      	    } 			
		}  
	}
	else
	{
	        fileNameFromHTTP="http://r.gismeteo.ru/r.php?sh+BARM+http://informer.gismeteo.ru/xml/"+index+"_1.xml";
	        resultat=loadFIleFromHTTP(fileNameFromHTTP);
	      	if (resultat=="Error")
	      	{
		   clear();
		   return;
	      	}
		else
	      	{
		   GismeteoBar_PREF.setCharPref("fileTime",date);
		   file=dir.path+'\\'+index+'.xml';
     		   //data = encodeClass.ConvertFromUnicode(resultat);
		   data =resultat;
		   saveXMLFile(file,data);
		 
	      	} 
	}
	

	try
	
	{
	   param=GismeteoBar_PREF.getCharPref("selectPrognoz"); 

	}catch(err) {param=2; GismeteoBar_PREF.setCharPref("selectPrognoz",2); }
	
	razborPrognoza(resultat,param,name);

}



function fileTime(fileName)
{
   try
   {
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.QueryInterface(Components.interfaces.nsIFile);
	file.initWithPath(fileName);
	return file.lastModifiedTime;
   }
   catch(err)
   {
	var str="Error";
	return str;
   }
}


function timeUpdate(date,filetime)
{
	
	var dateArray = new Array();
	dateArray=date.split("||");

	var filetimeArray=new Array();
	filetimeArray=filetime.split("||");

	if (filetimeArray[0]!=dateArray[0]) return true
	else
	{
	  if (filetimeArray[1]!=dateArray[1]) return true
	  else
	  {
		try{
		   var timeUpd=GismeteoBar_PREF.getCharPref("timeUpdate");}
		catch(err){timeUpd="0||6||12||18||24"} 
		var timeUpdArray = new Array();	
		timeUpdArray=timeUpd.split("||");
		for (var i=0; i<timeUpdArray.length-1;i++) 
		{
			if ((dateArray[3]>=timeUpdArray[i])&&(dateArray[3]<timeUpdArray[i+1]))
			{
				if (filetimeArray[3]<timeUpdArray[i]) return true;
				if (filetimeArray[3]>timeUpdArray[i+1]) return true;
				if ((filetimeArray[3]>=timeUpdArray[i])&&(filetimeArray[3]<timeUpdArray[i+1])) return false;
			}
		}
		
	  }
	}
	
}


function razborPrognoza(data,param,name)
{

	var windoc;
	if (Eflag==0) windoc=window.document;
	else windoc=window.opener.document;
	
	strbundle=windoc.getElementById("qq");

	var weekdays = strbundle.getString("gismeteobar.date.Day");	
	var weekdaysArray = new Array();
	weekdaysArray = weekdays.split("||");

	var months=strbundle.getString("gismeteobar.date.hint.Month");
	var monthsArray = new Array();
	monthsArray = months.split("||");

	var weekdays2=strbundle.getString("gismeteobar.date.hint.Day");
	var weekdaysArray2 = new Array();
	weekdaysArray2 = weekdays2.split("||");

	var cl=strbundle.getString("gismeteobar.hint.img");
	var clArray = new Array();
	clArray = cl.split("||");

	var wind=strbundle.getString("gismeteobar.wd");
	var windArray = new Array();
	windArray = wind.split("||");

	var xrequest = new DOMParser().parseFromString(data,'text/xml');


	for (i=0;i<xrequest.documentElement.childNodes.length;i++)
	{
	   try
           {
	      var node=xrequest.documentElement.childNodes.item(i);
	      if(node.nodeType==1) 
	      {
		 for (j=0;j<node.childNodes.length;j++)
	         {
		    var node1=node.childNodes.item(j);
                    if(node1.nodeType==1) 
		    {
		       for (k=0;k<node1.childNodes.length;k++)
		       {
		          var node2=node1.childNodes.item(k);
			  if(node2.nodeType==1)
			  {
			     tod=node2.getAttribute("tod");
			     if(tod!=param) {continue;}
			     day=node2.getAttribute("day");
			     month=node2.getAttribute("month");
			     weekday=node2.getAttribute("weekday");
			     var strDay=weekdaysArray[weekday-1];
			     if(param==0)  strDayNight='Night'; 
	                     if(param==2)  strDayNight='Day';
			     strCity=windoc.getElementById("strCity");
			     strCity.value=unescape(name);
			     strDate=windoc.getElementById("strDate");
			     str=strbundle.getString("gismeteobar."+strDayNight);	
	                     strDate.value=day+'/'+month+' '+strDay+' '+str;		     
			     tooltiptext=monthsArray[month-1]+': '+weekdaysArray2[weekday-1];
			     tooltiptext=day+' '+tooltiptext;
			     strDate.setAttribute('tooltiptext',tooltiptext);
			     for (p=0;p<node2.childNodes.length;p++)
			     {
				var parametrs = node2.childNodes.item(p);
				if(parametrs.nodeType==1)
				{
				   switch (parametrs.nodeName)
				   {
					case 'PHENOMENA':
					{
					   cloudiness=parametrs.getAttribute("cloudiness");
					   precipitation=parametrs.getAttribute("precipitation");
					   img=windoc.getElementById("cloudiness");

					   if(param==2) ext=".gif";
					   else ext="n.gif";

	if ((precipitation==4) || (precipitation==5))
	{
		if (cloudiness==2) { img.src="chrome://gismeteobar/skin/4"+ext; var tooltiptext=clArray[4];}
		if (cloudiness==3) { img.src="chrome://gismeteobar/skin/5"+ext; var tooltiptext=clArray[5];}
		
	}
	if ((precipitation==6) || (precipitation==7))
	{
		if (cloudiness==2) {img.src="chrome://gismeteobar/skin/6"+ext; var tooltiptext=clArray[6];}
		if (cloudiness==3) {img.src="chrome://gismeteobar/skin/7"+ext; var tooltiptext=clArray[7];}
		var tooltiptext=clArray[6];
	}
	if (precipitation==8) 
	{
		img.src="img/pics/8"+ext;
		clFrc.textcloudiness=imghintArray[8];		
	}
	if (precipitation==10) 
	{
		if (cloudiness==0) img.src="chrome://gismeteobar/skin/0"+ext;
		if (cloudiness==1) img.src="chrome://gismeteobar/skin/1"+ext;
		if (cloudiness==2) img.src="chrome://gismeteobar/skin/2"+ext;
		if (cloudiness==3) img.src="chrome://gismeteobar/skin/3"+ext;
		var tooltiptext=clArray[cloudiness];			
	}
	if (precipitation==9) 
	{
		img.src="chrome://gismeteobar/skin/9"+ext;
	}

					   img.setAttribute('tooltiptext',tooltiptext);
					}

					case 'PRESSURE':
					{
					   pr1=parametrs.getAttribute("min");
					   pr2=parametrs.getAttribute("max");
					   pr=((+pr1)+(+pr2)) / 2;
					   tooltiptext=strbundle.getString("gismeteobar.hint.pressure");
					   value=pr+' '+strbundle.getString("gismeteobar.hint.pr");
					   value=value;
					   pressure=windoc.getElementById("strPressure");
					   pressure.value=value;
					   pressure.setAttribute('tooltiptext',tooltiptext);
					}
					
					case 'TEMPERATURE':
					{
					   t1=parametrs.getAttribute("min");
					   t2=parametrs.getAttribute("max");
					   if (t1>=0) 
					   {
					   	if (t1>0) t1="+"+t1;
					   	t2="+"+t2;
						str=' '+t1+".."+t2+" "+"C";
					   } 
					   if (t2<=0)
					   {
						str=' '+t2+".."+t1+" "+"C";						
					   }
					   if ((t1<0)&&(t2>0)) str=' '+t1+".."+"+"+t2+" "+"C"; 
					   strTemper=windoc.getElementById("strTemper");
					   strTemper.value=str;
					   var tooltiptext=strbundle.getString("gismeteobar.hint.t");
					   strTemper.setAttribute('tooltiptext',tooltiptext);
					}

					case 'WIND':
					{
					   wdir=parametrs.getAttribute("direction");
					   strwdir=windArray[(+wdir)];
					   value=strwdir+',';
					   strWdir=windoc.getElementById("strWdir");
					   tooltiptext=strbundle.getString("gismeteobar.hint.wd");
					   strWdir.setAttribute('tooltiptext',tooltiptext);
					   
					   ws1=parametrs.getAttribute("min");
					   ws2=parametrs.getAttribute("min");
					   ws=((+ws1)+(+ws2))/2;
					   w=strbundle.getString("gismeteobar.ws");
					   strWdir.value=strwdir+', '+ws+' '+w;
					}
		
					case 'RELWET':
					{
					   w1=parametrs.getAttribute("min");
					   w2=parametrs.getAttribute("max");
					   value=(+w1)+(+2);
					   strWet=windoc.getElementById("strWet");
					   strWet.value=value+'%';
					   tooltiptext=strbundle.getString("gismeteobar.hint.relwet");
					   strWet.setAttribute('tooltiptext',tooltiptext);  					   
					}
				   }
				}	
			     }
			     		

		          } 

	               }

		    }
					
	          }	

	       }

            }    
	    catch(err) {alert(err);}
	}
}


function selectPrognoz(event)
{
	try {
	  param=GismeteoBar_PREF.getCharPref("selectPrognoz");}
	catch(err) {param=2}
	if ((param!=0)&&(param!=2)) {GismeteoBar_PREF.setCharPref("selectPrognoz", "2"); return;} 
	if(param==0) {GismeteoBar_PREF.setCharPref("selectPrognoz", "2");}
	else {GismeteoBar_PREF.setCharPref("selectPrognoz", "0");}
	beforeshowPrognoz();	
}



function GoTo(event, type)
{
	index=GismeteoBar_PREF.getCharPref("selectIndexTown");

	try {country=GismeteoBar_PREF.getCharPref("selectNameCountry");
	} catch(err) {country='%u0420%u043E%u0441%u0441%u0438%u044F'; GismeteoBar_PREF.setCharPref("selectNameCountry",country);}

	if (country=='%u0423%u043A%u0440%u0430%u0438%u043D%u0430') URL = "http://www.gismeteo.ua/towns/"+index+".htm";	
	else URL = "http://www.gismeteo.ru/towns/"+index+".htm";

	GBLTut_LoadURL(URL);

}

function GoToGismeteo(event, type)
{

	try {country=GismeteoBar_PREF.getCharPref("selectNameCountry");
	} catch(err) {country='%u0420%u043E%u0441%u0441%u0438%u044F'; GismeteoBar_PREF.setCharPref("selectNameCountry",country);}

	if (country=='%u0423%u043A%u0440%u0430%u0438%u043D%u0430') URL = "http://www.gismeteo.ua/";	
	else URL = "http://www.gismeteo.ru/";

	GBLTut_LoadURL(URL);
    
}


////////////////////////////////  //////////////////////////////////////////////////////////

function loadFIle(fileName,PathToFile)
{
      try
      {
	var localFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	localFile.initWithPath(PathToFile);
	localFile.append(fileName);
        var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	stream.init(localFile, 1, 0, null); 
	sis.init(stream);
	var data = sis.read(-1);
        sis.close();
        stream.close(); 	
	return data;
      }
      catch(err)
      {
	return "Error";
      }	    
}

/////////////////////////////////   http/////////////////////////////////////////////////////////////

function loadFIleFromHTTP(fileName)
{
  try
  {
     var url=fileName;
     var zapros=new XMLHttpRequest();
     zapros.open("GET",url,false);
     zapros.send("");
     return zapros.responseText;
  }
  catch(err)
  {
     return "Error";
  }	
     
}


///////////////////////////////// ///////////////////////////////////////////////////////////////////

function saveXMLFile(fileName,text)
{
   try
   {
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.QueryInterface(Components.interfaces.nsIFile);
	file.initWithPath(fileName);
	var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	strm.QueryInterface(Components.interfaces.nsIOutputStream);
	strm.QueryInterface(Components.interfaces.nsISeekableStream);
	strm.init( file, 0x02 | 0x08 | 0x20, 0420, 0 );
	strm.write(text, text.length);
	strm.close();
   }
   catch(err)
   {
	alert(err);
	var str="null";
	return str;
   }
}

function GBLTut_LoadURL(URL)
{
	window._content.document.location = "http://r.gismeteo.ru/r.php?cl+BARM+"+URL;
	window.content.focus();
}

function selectPozition()
{
	var searchTown = document.getElementById("Gismeteo-Towns-Menu");
	searchTown.selectedIndex=GismeteoBar_PREF.getCharPref("selectIndex");
}


function Reload(event)
{

	index=GismeteoBar_PREF.getCharPref("selectIndexTown");	
	name=unescape(GismeteoBar_PREF.getCharPref("selectNameTown"));	
	fileNameFromHTTP="http://r.gismeteo.ru/r.php?sh+BARM+http://informer.gismeteo.ru/xml/"+index+"_1.xml";
	resultat=loadFIleFromHTTP(fileNameFromHTTP);
	if (resultat=="Error") return
	else 
	{
	   file=dir.path+'\\'+index+'.xml';
     	   data = resultat;
	   saveXMLFile(file,data); 
	}     

	param=GismeteoBar_PREF.getCharPref("selectPrognoz"); 

	razborPrognoza(resultat,param,name);	
	
}

function clear()
{
	var windoc;
	if (Eflag==0) windoc=window.document;
	else windoc=window.opener.document;
	
	strbundle=windoc.getElementById("qq");
	
	strCity=windoc.getElementById("strCity");
	strCity.value='';
	strDate=windoc.getElementById("strDate");
	strDate.value=strbundle.getString("gismeteobar.ErrorConnection");
	img=windoc.getElementById("cloudiness");
	img.src="chrome://gismeteobar/skin/er.gif"
	pressure=windoc.getElementById("strPressure");
	pressure.value='';
	strTemper=windoc.getElementById("strTemper");
	strTemper.value='';
	strWdir=windoc.getElementById("strWdir");
	strWdir.value='';
	strWet=windoc.getElementById("strWet");
	strWet.value='';
}